/* Parallel Hierarchical Grid -- an adaptive finite element library.
 *
 * Copyright (C) 2005-2010 State Key Laboratory of Scientific and
 * Engineering Computing, Chinese Academy of Sciences. */

/* This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA */

/* $Id: distribute.h,v 1.12 2010/07/01 05:50:45 zlb Exp $ */

#ifndef PHG_DISTRIBUTE_H

typedef BOOLEAN (*PARTITIONER)(GRID *g, int nprocs, DOF *weights, FLOAT power);

#ifdef __cplusplus
extern "C" {
#endif

#if USE_MPI
int  phgCreateComm_(int nprocs, MPI_Comm *comm);
void phgUpdateRNeighbours_(GRID *g);
void phgRebuildL2Gmap_(GRID *g, GTYPE type);
#endif
PARTITIONER phgGetPartitioner(int no);
void phgPartitionGrid__(GRID *g);
#define phgPartitionGrid	phgRedistributeGrid
void phgRedistributeGrid(GRID *g);
int  phgBalanceGrid(GRID *g, FLOAT lif_threshold, INT submesh_threshold,
	struct DOF_ *weights, FLOAT power);

#ifdef __cplusplus
}
#endif

#define PHG_DISTRIBUTE_H
#endif
